unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, header;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton_FileOpen1: TToolButton;
    ToolButton_FileSave1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton_EditCut1: TToolButton;
    ToolButton_EditCopy1: TToolButton;
    ToolButton_EditPaste1: TToolButton;
    ToolButton_FileNew1: TToolButton;
    ToolButton_WindowCascade1: TToolButton;
    ToolButton_WindowTileHorizontal1: TToolButton;
    ToolButton_WindowTileVertical1: TToolButton;
    ImageList1: TImageList;
    ToolButton12: TToolButton;
    ToolButton_MovePoint: TToolButton;
    ToolButton_DrowLine: TToolButton;
    N2: TMenuItem;
    N3: TMenuItem;
    Show1: TMenuItem;
    PasteLR: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    Camera1: TMenuItem;
    typeOrthogonal: TMenuItem;
    typePerspective: TMenuItem;
    N19: TMenuItem;
    InitPosition: TMenuItem;
    TrackUpBack: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    GondolaSlide: TMenuItem;
    SelectAll: TMenuItem;
    N26: TMenuItem;
    S1: TMenuItem;
    N27: TMenuItem;
    N14: TMenuItem;
    N21: TMenuItem;
    N28: TMenuItem;
    N29: TMenuItem;
    N30: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    N34: TMenuItem;
    N35: TMenuItem;
    LensProperty: TMenuItem;
    N39: TMenuItem;
    N42: TMenuItem;
    N43: TMenuItem;
    N44: TMenuItem;
    N45: TMenuItem;
    N46: TMenuItem;
    N47: TMenuItem;
    N7: TMenuItem;
    N9: TMenuItem;
    N31: TMenuItem;
    N38: TMenuItem;
    N48: TMenuItem;
    N49: TMenuItem;
    N50: TMenuItem;
    N51: TMenuItem;
    N40: TMenuItem;
    N52: TMenuItem;
    N53: TMenuItem;
    N54: TMenuItem;
    N55: TMenuItem;
    N56: TMenuItem;
    N59: TMenuItem;
    N60: TMenuItem;
    Movemode: TMenuItem;
    Auto3D: TMenuItem;
    Pallalel: TMenuItem;
    XY1: TMenuItem;
    YZ1: TMenuItem;
    XZ1: TMenuItem;
    N65: TMenuItem;
    N66: TMenuItem;
    Only3D: TMenuItem;
    N68: TMenuItem;
    auto3DProperty: TMenuItem;
    N70: TMenuItem;
    N71: TMenuItem;
    N72: TMenuItem;
    WindowTileItem3d: TMenuItem;
    N74: TMenuItem;
    N75: TMenuItem;
    N76: TMenuItem;
    N77: TMenuItem;
    N78: TMenuItem;
    N79: TMenuItem;
    N80: TMenuItem;
    N37: TMenuItem;
    N41: TMenuItem;
    Edit_PasteLR: TAction;
    WalkThrough: TMenuItem;
    WalkParallel: TMenuItem;
    File_ExportFile: TAction;
    Edit_SelectAll: TAction;
    View_FaceOnly: TAction;
    View_PointAndLine: TAction;
    Process_PutFacesAllPoly: TAction;
    Action2: TAction;
    Movemode_XY: TAction;
    Action4: TAction;
    Action5: TAction;
    View_PointAndLineAndFace: TAction;
    View_LineAndFace: TAction;
    View_ExpansionReduction: TAction;
    View_ShiftPosition: TAction;
    View_InitPosition: TAction;
    View_HiddenSymmetry: TAction;
    Camera_typeOrthogonal: TAction;
    Camera_typePerspective: TAction;
    Camera_LensProperty: TAction;
    Camera_TrackUpBack: TAction;
    Camera_GondolaSlide: TAction;
    Camera_WalkThrough: TAction;
    Camera_WalkParallel: TAction;
    Camera_InitPosition: TAction;
    Camera_LockForTrace: TAction;
    Process_PutFacesSelectedPoly: TAction;
    Process_DelFacesSelectedPoly: TAction;
    Process_ModelPropeties: TAction;
    N84: TMenuItem;
    typeRotation: TMenuItem;
    Camera_typeRotation: TAction;
    View_Turn: TAction;
    Process_Magnify: TAction;
    Process_Strecth: TAction;
    Process_Rotate: TAction;
    Process_Duplicate: TAction;
    Process_Extend: TAction;
    Process_Raise: TAction;
    Process_ModelHide: TAction;
    Process_ModelShow: TAction;
    View_ModelTemporarilyShowAll: TAction;
    Process_ProcessDialog: TAction;
    N85: TMenuItem;
    N58: TMenuItem;
    typeOrthogonalLens: TMenuItem;
    Camera_typeOrthogonalLens: TAction;
    tmRefresh: TTimer;
    Camera_typeEquidistanceLens: TAction;
    typeEquidistanceLens: TMenuItem;
    Camera_ChangePars: TAction;
    ChangePars: TMenuItem;
    Camera_ParsAbsorbed: TAction;
    ParsAbsorbed: TMenuItem;
    N88: TMenuItem;
    N89: TMenuItem;

    Mode_DrowLine: TAction;
    Mode_MovePoint: TAction;
    ToolButton_Movemode_XZ: TToolButton;
    ToolButton_Movemode_XY: TToolButton;
    ToolButton_Movemode_YZ: TToolButton;
    ToolButton_Movemode_Palallel: TToolButton;
    ToolButton_Movemode_auto3D: TToolButton;
    ToolButton20: TToolButton;
    Movemode_YZ: TAction;
    ToolButton_Mode_ChangePCameraLeng: TToolButton;
    ToolButton_Mode_ChangePPlainLeng: TToolButton;
    ToolButton_Mode_ChangeNOffset2D: TToolButton;
    ToolButton_Mode_MoveGroup: TToolButton;
    ToolButton25: TToolButton;
    ToolButton_Mode_ChangeOffset3D: TToolButton;
    ToolButton_Mode_ChangeExpan2D: TToolButton;
    ToolButton28: TToolButton;
    ToolButton_WindowTile3rdPageStyle1: TToolButton;
    ToolButton_Mode_SymmetricalCorrelation: TToolButton;
    WindowTile3rdPageStyle1: TAction;
    Movemode_XZ: TAction;
    Movemode_Palallel: TAction;
    Movemode_auto3D: TAction;
    Movemode_only3D: TAction;
    Mode_MoveGroup: TAction;
    Mode_SymmetricalCorrelation: TAction;
    Mode_ChangeOffset3D: TAction;
    Mode_ChangePCameraLeng: TAction;
    Mode_ChangePPlainLeng: TAction;
    Mode_ChangeNOffset2D: TAction;
    Mode_ChangeExpan2D: TAction;
    ToolButton_DrowLineSynm: TToolButton;
    Mode_DrowLineSynm: TAction;
    SaveDialogOrg: TSaveDialog;
    SaveDialogRok: TSaveDialog;

    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure Camera_typePerspectiveExecute(Sender: TObject);
    procedure Camera_typeOrthogonalExecute(Sender: TObject);
    procedure tmRefreshTimer(Sender: TObject);
    procedure Camera_typeOrthogonalLensExecute(Sender: TObject);
    procedure Camera_typeEquidistanceLensExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Mode_DrowLineExecute(Sender: TObject);
    procedure Mode_MovePointExecute(Sender: TObject);
    procedure Movemode_XYExecute(Sender: TObject);
    procedure Movemode_YZExecute(Sender: TObject);
    procedure Movemode_XZExecute(Sender: TObject);
    procedure Movemode_PalallelExecute(Sender: TObject);
    procedure Movemode_auto3DExecute(Sender: TObject);
    procedure Mode_DrowLineSynmExecute(Sender: TObject);
    procedure FileSaveAs1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
  private
    { Private 錾 }
    procedure CreateMDIChild(const Name: string);
  public
    { Public 錾 }

    Ary3DData     : T3DDataAry; // 3Df[^
    Lnk3DLine     : P3DLine;    // Cf[^Xg
    Ary3DDataFix  : T3DDataAry; // L[u
    Lnk3DLineFix  : P3DLine;    // Cf[^Xg
    DataAryAry    : T3DDataAryAry;    // Cf[^Xg

//    Ary3DTemp : T3DDataAry; // 3Df[^e|
//    CountTemp : integer;    // _̐
//    Lnk3DLineTmp : P3DLine; // Cf[^Xg
    MKPAry : TMKPointAry;
    MovingPoint: integer;
//    OldCStat, CmpCStat : TCameraStatus;  // JXe[^X
    DatStat_OldCam, DatStat_CmpCam : TCwinStatus;  // ̉pJXe[^X

    AppStat_CatchPointLength : Integer; //NbŇ덷␳
    AppStat_LineDivLength : Integer; //Ȑ̊炩
    AppStat_LastEditImmidiate : Integer; //ŌɐG_̋ 0 1
    AppStat_MoveMode : Integer; //ړ@PT_MMode**

    AppStat_SafeArea : Double;
    AppStat_SafeDeg  : Double;

    procedure UpdateCameraStat(mv3d: T3DData; DatStat_NowCam: TCwinStatus);

    procedure DataSaveFile(filename: string);
    procedure DataLoadFile(filename: string);
    procedure DataClear();


  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin, About, LoopThread;

//-----------------------------------------------------------------------------
// tH[NGCg
//-----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
var
 i: integer;
 lpth: TLoop;
begin
  for i:= 0 to MaxAryPoint
  do begin
    Ary3DData[i].Status := 0;
    Ary3DDataFix[i].Status := 0;
  end;
//  CountTemp := 0;
  MovingPoint := 0;
  Lnk3DLine := nil;
//  Lnk3DLineTmp := nil;

  AppStat_CatchPointLength := 4;
  AppStat_LineDivLength := 5;
  AppStat_LastEditImmidiate := 0;//ŌɐG_̋iΏ̗̉pj

  AppStat_SafeArea :=5 ;
  AppStat_SafeDeg  :=0.4;

  DatStat_OldCam.Offset3D.X := 0;
  DatStat_OldCam.Offset3D.Y := 0;
  DatStat_OldCam.Offset3D.Z := 0;
  DatStat_OldCam.Xtheta := 0;
  DatStat_OldCam.Ytheta := 0;
  DatStat_OldCam.PPlainL := 0;
  DatStat_OldCam.PCameraL := 0;
  DatStat_OldCam.LensType := tlPars;

  DatStat_CmpCam := DatStat_OldCam;

  lpth := TLoop.Create(False);
  lpth.Priority := tpLowest;
  //lpth.Priority := tpIdle;
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { MDI qEBhE쐬 }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

//-----------------------------------------------------------------------------
// t@CJ
//-----------------------------------------------------------------------------
procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute
  then begin
    DataLoadFile(OpenDialog.FileName);
  end;
  //  CreateMDIChild(OpenDialog.FileName);
end;

//-----------------------------------------------------------------------------
// Otĕۑ
//-----------------------------------------------------------------------------
procedure TMainForm.FileSaveAs1Execute(Sender: TObject);
begin
  if SaveDialogOrg.Execute
  then begin
    DataSaveFile(SaveDialogOrg.FileName);
  end;
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure TMainForm.FileSave1Execute(Sender: TObject);
begin
//
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

//-----------------------------------------------------------------------------
// J|We
//-----------------------------------------------------------------------------
procedure TMainForm.Camera_typePerspectiveExecute(Sender: TObject);
begin
  if MDIChildCount > 0
  then begin
    (MDIChildren[0] as TMDIChild).SetLensType(tlPars);
  end;
end;

//-----------------------------------------------------------------------------
// J|se
//-----------------------------------------------------------------------------
procedure TMainForm.Camera_typeOrthogonalExecute(Sender: TObject);
begin
  if MDIChildCount > 0
  then begin
    (MDIChildren[0] as TMDIChild).SetLensType(tlOrtho);
  end;
end;


//-----------------------------------------------------------------------------
// J|e
//-----------------------------------------------------------------------------
procedure TMainForm.Camera_typeEquidistanceLensExecute(Sender: TObject);
begin
  if MDIChildCount > 0
  then begin
    (MDIChildren[0] as TMDIChild).SetLensType(tlEquidlens);
  end;
end;

//-----------------------------------------------------------------------------
// J|ˉeY
//-----------------------------------------------------------------------------
procedure TMainForm.Camera_typeOrthogonalLensExecute(Sender: TObject);
begin
  if MDIChildCount > 0
  then begin
    (MDIChildren[0] as TMDIChild).SetLensType(tlOrtholens);
  end;
end;

//-----------------------------------------------------------------------------
// ^C}[
//-----------------------------------------------------------------------------
procedure TMainForm.tmRefreshTimer(Sender: TObject);
var
  i: integer;
begin
//
  if MDIChildCount > 0
  then begin
    for i := 0 to MDIChildCount - 1
    do begin
      (MDIChildren[i] as TMDIChild).WriteWindow;
    end;
  end;
end;



//-----------------------------------------------------------------------------
// _u[h
//-----------------------------------------------------------------------------
procedure TMainForm.Mode_DrowLineExecute(Sender: TObject);
begin
  Mode_DrowLine.Checked := true;
end;

//-----------------------------------------------------------------------------
// _݃[h
//-----------------------------------------------------------------------------
procedure TMainForm.Mode_MovePointExecute(Sender: TObject);
begin
  Mode_MovePoint.Checked := true;
end;

//-----------------------------------------------------------------------------
// JXe[^X̍XV
//-----------------------------------------------------------------------------
procedure TMainForm.UpdateCameraStat(mv3d: T3DData; DatStat_NowCam: TCwinStatus);
begin
//  if  (DatStat_NowCam.Offset3D.X = DatStat_CmpCam.Offset3D.X) and
//      (DatStat_NowCam.Offset3D.Y = DatStat_CmpCam.Offset3D.Y) and
//      (DatStat_NowCam.Offset3D.Z = DatStat_CmpCam.Offset3D.Z) and
//      (DatStat_NowCam.Xtheta   = DatStat_CmpCam.Xtheta) and
//      (DatStat_NowCam.Ytheta   = DatStat_CmpCam.Ytheta) and
//      (DatStat_NowCam.LensType = DatStat_CmpCam.LensType) and
//      (DatStat_NowCam.PPlainL = DatStat_CmpCam.PPlainL) and
//      (DatStat_NowCam.PCameraL = DatStat_CmpCam.PCameraL) and
//      (DatStat_NowCam.Immidiate = DatStat_CmpCam.Immidiate)

  if  (DatStat_NowCam.Camera3D.X = DatStat_CmpCam.Camera3D.X) and
      (DatStat_NowCam.Camera3D.Y = DatStat_CmpCam.Camera3D.Y) and
      (DatStat_NowCam.Camera3D.Z = DatStat_CmpCam.Camera3D.Z) and
//      (DatStat_NowCam.Immidiate = DatStat_CmpCam.Immidiate)

      (((DatStat_NowCam.Immidiate = -1) and (DatStat_CmpCam.Immidiate = -1))or
       ((DatStat_NowCam.Immidiate <> -1) and (DatStat_CmpCam.Immidiate <> -1)))

        // PPL PCL ͖
  then begin

    DatStat_CmpCam := DatStat_NowCam;

    if -1 = DatStat_NowCam.Immidiate
    then begin
      DatStat_CmpCam.Camera3D.X := -(DatStat_NowCam.Camera3D.X);
    end;

  end
  else begin

    DatStat_OldCam := DatStat_CmpCam;
    DatStat_CmpCam := DatStat_NowCam;

    if -1 = DatStat_NowCam.Immidiate
    then begin
      DatStat_CmpCam.Camera3D.X := -(DatStat_NowCam.Camera3D.X);
   end;
  end;

end;

//-----------------------------------------------------------------------------
// ړύX@wxŒ
//-----------------------------------------------------------------------------
procedure TMainForm.Movemode_XYExecute(Sender: TObject);
begin
  ToolButton_Movemode_XY.Down := true;
  AppStat_MoveMode := PT_MModeXY;
end;

//-----------------------------------------------------------------------------
// ړύX@xyŒ
//-----------------------------------------------------------------------------
procedure TMainForm.Movemode_YZExecute(Sender: TObject);
begin
  ToolButton_Movemode_YZ.Down := true;
  AppStat_MoveMode := PT_MModeYZ;
end;

//-----------------------------------------------------------------------------
// ړύX@wyŒ
//-----------------------------------------------------------------------------
procedure TMainForm.Movemode_XZExecute(Sender: TObject);
begin
  ToolButton_Movemode_XZ.Down := true;
  AppStat_MoveMode := PT_MModeXZ;
end;

//-----------------------------------------------------------------------------
// ړύX@ɕs
//-----------------------------------------------------------------------------
procedure TMainForm.Movemode_PalallelExecute(Sender: TObject);
begin
  ToolButton_Movemode_Palallel.Down := true;
  AppStat_MoveMode := PT_MModePalallel;
end;

//-----------------------------------------------------------------------------
// ړύX@̉
//-----------------------------------------------------------------------------

procedure TMainForm.Movemode_auto3DExecute(Sender: TObject);
begin
  ToolButton_Movemode_auto3D.Down := true;
  AppStat_MoveMode := PT_MModeAuto3D;
end;



//-----------------------------------------------------------------------------
// EΏ̓̓[h
//-----------------------------------------------------------------------------
procedure TMainForm.Mode_DrowLineSynmExecute(Sender: TObject);
begin
  Mode_DrowLineSynm.Checked := true;
end;

//-----------------------------------------------------------------------------
// f[^NA
//-----------------------------------------------------------------------------
procedure TMainForm.DataClear;
var
  i: integer;
  p3d, p3del: P3DLine;
begin
  for i:= 0 to MaxAryPoint
  do begin
    Ary3DData[i].Status := 0;
  end;
  p3del := Lnk3DLine;
  if nil <> p3del
  then begin
    repeat
      p3d := p3del.NextL;
      dispose(p3del);
      p3del := p3d;
    until nil <> p3d
  end;
  Lnk3DLine := nil;
end;

//-----------------------------------------------------------------------------
// f[^ǂݏo
//-----------------------------------------------------------------------------
procedure TMainForm.DataLoadFile(filename: string);
var
  sl: TStringList;
  i, kind, pno: integer;
  v3ddata : T3DData;
  a,b: P3DLine;
begin
  DataClear;

  sl := TStringList.Create;
  sl.LoadFromFile(filename);

  kind := 0;
  pno := 0;
  a := nil;
  b := nil;
  // ǂݏo
  for i := 0 to sl.Count - 1
  do begin
    if '[point]' = sl[i]
    then begin
      kind := 1;
      continue;
    end;
    if '[line]'  = sl[i]
    then begin
      kind := 2;
      new(a);
      Lnk3DLine := a;
      a.NextL := nil;
      continue;
    end;
    if 1 = kind
    then begin
      case pno of
      0:begin
        v3ddata.World.X   := StrToFloatDef(sl[i], 0);
      end;
      1:begin
        v3ddata.World.Y   := StrToFloatDef(sl[i], 0);
      end;
      2:begin
        v3ddata.World.Z   := StrToFloatDef(sl[i], 0);
      end;
      3:begin
        v3ddata.Flat.X    := StrToIntDef(sl[i], 0);
      end;
      4:begin
        v3ddata.Flat.Y    := StrToIntDef(sl[i], 0);
      end;
      5:begin
        v3ddata.Flat3D.X  := StrToFloatDef(sl[i], 0);
      end;
      6:begin
        v3ddata.Flat3D.Y  := StrToFloatDef(sl[i], 0);
      end;
      7:begin
        v3ddata.Flat3D.Z  := StrToFloatDef(sl[i], 0);
      end;
      8:begin
        v3ddata.Number    := StrToIntDef(sl[i], 0);
      end;
      9:begin
        v3ddata.Group     := StrToIntDef(sl[i], 0);
      end;
      10:begin
        v3ddata.View      := StrToIntDef(sl[i], 0);
      end;
      11:begin
        v3ddata.Dim       := StrToIntDef(sl[i], 0);
      end;
      12:begin
        v3ddata.Status    := StrToIntDef(sl[i], 0);
      end;
      13:begin
        v3ddata.Immidiate := StrToIntDef(sl[i], 0);

        Ary3DData[v3ddata.Number] := v3ddata;
        pno := -1;
      end;
      end;
      inc(pno);
    end;
    if 2 = kind
    then begin
      case pno of
      0:begin
        a.Point1 := StrToIntDef(sl[i], 0);
      end;
      1:begin
        a.Point2 := StrToIntDef(sl[i], 0);
      end;
      2:begin
        a.Group := StrToIntDef(sl[i], 0);
      end;
      3:begin
        a.View := StrToIntDef(sl[i], 0);
      end;
      4:begin
        a.Selected := StrToIntDef(sl[i], 0);
        new(b);
        b.NextL := nil;
        a.NextL := b;
        b := a;
        a := a.NextL;
        pno := -1;
      end;
      end;
      inc(pno);
    end;
  end;
  Dispose(a);
  b.NextL := nil;

  sl.Free;
end;

//-----------------------------------------------------------------------------
// f[^ۑ
//-----------------------------------------------------------------------------
procedure TMainForm.DataSaveFile(filename: string);
var
  sl: TStringList;
  i: integer;
  p3d: P3DLine;
begin
  sl := TStringList.Create;

  // 
  sl.Clear;

  // _f[^
  sl.Add('[point]');
  for i:= 0 to MaxAryPoint
  do begin
    if 0 <> (PT_Alived and Ary3DData[i].Status)
    then begin
      sl.Add(FloatToStr(Ary3DData[i].World.X));   //  0
      sl.Add(FloatToStr(Ary3DData[i].World.Y));   //  1
      sl.Add(FloatToStr(Ary3DData[i].World.Z));   //  2
      sl.Add(IntToStr(Ary3DData[i].Flat.X));      //  3
      sl.Add(IntToStr(Ary3DData[i].Flat.Y));      //  4
      sl.Add(FloatToStr(Ary3DData[i].Flat3D.X));  //  5
      sl.Add(FloatToStr(Ary3DData[i].Flat3D.Y));  //  6
      sl.Add(FloatToStr(Ary3DData[i].Flat3D.Z));  //  7

      sl.Add(IntToStr(Ary3DData[i].Number));      //  8
      sl.Add(IntToStr(Ary3DData[i].Group));       //  9
      sl.Add(IntToStr(Ary3DData[i].View));        // 10
      sl.Add(IntToStr(Ary3DData[i].Dim));         // 11
      sl.Add(IntToStr(Ary3DData[i].Status));      // 12
      sl.Add(IntToStr(Ary3DData[i].Immidiate));   // 13
    end;
  end;

  // f[^
  sl.Add('[line]');
  p3d := Lnk3DLine;
  while nil <> p3d
  do begin
    sl.Add(IntToStr(p3d.Point1));     // 0
    sl.Add(IntToStr(p3d.Point2));     // 1
    sl.Add(IntToStr(p3d.Group));      // 2
    sl.Add(IntToStr(p3d.View));       // 3
    sl.Add(IntToStr(p3d.Selected));   // 4
    p3d := p3d.NextL;
  end;



  sl.SaveToFile(filename);
  sl.Free;
end;

end.
//-----------------------------------------------------------------------------

